Index: /branches/version-2_11-dev/data/module/fpdf/fpdf.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/fpdf.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/fpdf.php	(revision 20993)
@@ -1405,25 +1481,27 @@
 		if(isset($this->PageLinks[$n]))
 		{
-			//Links
-			$annots='/Annots [';
+			// Links
+			$annots = '/Annots [';
 			foreach($this->PageLinks[$n] as $pl)
 			{
-				$rect=sprintf('%.2F %.2F %.2F %.2F',$pl[0],$pl[1],$pl[0]+$pl[2],$pl[1]-$pl[3]);
-				$annots.='<</Type /Annot /Subtype /Link /Rect ['.$rect.'] /Border [0 0 0] ';
+				$rect = sprintf('%.2F %.2F %.2F %.2F',$pl[0],$pl[1],$pl[0]+$pl[2],$pl[1]-$pl[3]);
+				$annots .= '<</Type /Annot /Subtype /Link /Rect ['.$rect.'] /Border [0 0 0] ';
 				if(is_string($pl[4]))
-					$annots.='/A <</S /URI /URI '.$this->_textstring($pl[4]).'>>>>';
+					$annots .= '/A <</S /URI /URI '.$this->_textstring($pl[4]).'>>>>';
 				else
 				{
-					$l=$this->links[$pl[4]];
-					$h=isset($this->PageSizes[$l[0]]) ? $this->PageSizes[$l[0]][1] : $hPt;
-					$annots.=sprintf('/Dest [%d 0 R /XYZ 0 %.2F null]>>',1+2*$l[0],$h-$l[1]*$this->k);
+					$l = $this->links[$pl[4]];
+					$h = isset($this->PageSizes[$l[0]]) ? $this->PageSizes[$l[0]][1] : $hPt;
+					$annots .= sprintf('/Dest [%d 0 R /XYZ 0 %.2F null]>>',1+2*$l[0],$h-$l[1]*$this->k);
 				}
 			}
 			$this->_out($annots.']');
 		}
+		if($this->PDFVersion>'1.3')
+			$this->_out('/Group <</Type /Group /S /Transparency /CS /DeviceRGB>>');
 		$this->_out('/Contents '.($this->n+1).' 0 R>>');
 		$this->_out('endobj');
-		//Page content
-		$p=($this->compress) ? gzcompress($this->pages[$n]) : $this->pages[$n];
+		// Page content
+		$p = ($this->compress) ? gzcompress($this->pages[$n]) : $this->pages[$n];
 		$this->_newobj();
 		$this->_out('<<'.$filter.'/Length '.strlen($p).'>>');
@@ -1431,11 +1509,11 @@
 		$this->_out('endobj');
 	}
-	//Pages root
-	$this->offsets[1]=strlen($this->buffer);
+	// Pages root
+	$this->offsets[1] = strlen($this->buffer);
 	$this->_out('1 0 obj');
 	$this->_out('<</Type /Pages');
-	$kids='/Kids [';
+	$kids = '/Kids [';
 	for($i=0;$i<$nb;$i++)
-		$kids.=(3+2*$i).' 0 R ';
+		$kids .= (3+2*$i).' 0 R ';
 	$this->_out($kids.']');
 	$this->_out('/Count '.$nb);
@@ -1447,8 +1525,8 @@
 function _putfonts()
 {
-	$nf=$this->n;
+	$nf = $this->n;
 	foreach($this->diffs as $diff)
 	{
-		//Encodings
+		// Encodings
 		$this->_newobj();
 		$this->_out('<</Type /Encoding /BaseEncoding /WinAnsiEncoding /Differences ['.$diff.']>>');
@@ -1457,29 +1535,13 @@
 	foreach($this->FontFiles as $file=>$info)
 	{
-		//Font file embedding
+		// Font file embedding
 		$this->_newobj();
-		$this->FontFiles[$file]['n']=$this->n;
-		$font='';
-		$f=fopen($this->_getfontpath().$file,'rb',1);
-		if(!$f)
-			$this->Error('Font file not found');
-		while(!feof($f))
-			$font.=fread($f,8192);
-		fclose($f);
-		$compressed=(substr($file,-2)=='.z');
+		$this->FontFiles[$file]['n'] = $this->n;
+		$font = file_get_contents($this->fontpath.$file,true);
+		if(!$font)
+			$this->Error('Font file not found: '.$file);
+		$compressed = (substr($file,-2)=='.z');
 		if(!$compressed && isset($info['length2']))
-		{
-			$header=(ord($font[0])==128);
-			if($header)
-			{
-				//Strip first binary header
-				$font=substr($font,6);
-			}
-			if($header && ord($font[$info['length1']])==128)
-			{
-				//Strip second binary header
-				$font=substr($font,0,$info['length1']).substr($font,$info['length1']+6);
-			}
-		}
+			$font = substr($font,6,$info['length1']).substr($font,6+$info['length1']+6,$info['length2']);
 		$this->_out('<</Length '.strlen($font));
 		if($compressed)
@@ -1494,11 +1556,11 @@
 	foreach($this->fonts as $k=>$font)
 	{
-		//Font objects
-		$this->fonts[$k]['n']=$this->n+1;
-		$type=$font['type'];
-		$name=$font['name'];
-		if($type=='core')
-		{
-			//Standard font
+		// Font objects
+		$this->fonts[$k]['n'] = $this->n+1;
+		$type = $font['type'];
+		$name = $font['name'];
+		if($type=='Core')
+		{
+			// Core font
 			$this->_newobj();
 			$this->_out('<</Type /Font');
@@ -1512,5 +1574,5 @@
 		elseif($type=='Type1' || $type=='TrueType')
 		{
-			//Additional Type1 or TrueType font
+			// Additional Type1 or TrueType/OpenType font
 			$this->_newobj();
 			$this->_out('<</Type /Font');
@@ -1520,29 +1582,25 @@
 			$this->_out('/Widths '.($this->n+1).' 0 R');
 			$this->_out('/FontDescriptor '.($this->n+2).' 0 R');
-			if($font['enc'])
-			{
-				if(isset($font['diff']))
-					$this->_out('/Encoding '.($nf+$font['diff']).' 0 R');
-				else
-					$this->_out('/Encoding /WinAnsiEncoding');
-			}
+			if(isset($font['diffn']))
+				$this->_out('/Encoding '.($nf+$font['diffn']).' 0 R');
+			else
+				$this->_out('/Encoding /WinAnsiEncoding');
 			$this->_out('>>');
 			$this->_out('endobj');
-			//Widths
+			// Widths
 			$this->_newobj();
-			$cw=&$font['cw'];
-			$s='[';
+			$cw = &$font['cw'];
+			$s = '[';
 			for($i=32;$i<=255;$i++)
-				$s.=$cw[chr($i)].' ';
+				$s .= $cw[chr($i)].' ';
 			$this->_out($s.']');
 			$this->_out('endobj');
-			//Descriptor
+			// Descriptor
 			$this->_newobj();
-			$s='<</Type /FontDescriptor /FontName /'.$name;
+			$s = '<</Type /FontDescriptor /FontName /'.$name;
 			foreach($font['desc'] as $k=>$v)
-				$s.=' /'.$k.' '.$v;
-			$file=$font['file'];
-			if($file)
-				$s.=' /FontFile'.($type=='Type1' ? '' : '2').' '.$this->FontFiles[$file]['n'].' 0 R';
+				$s .= ' /'.$k.' '.$v;
+			if(!empty($font['file']))
+				$s .= ' /FontFile'.($type=='Type1' ? '' : '2').' '.$this->FontFiles[$font['file']]['n'].' 0 R';
 			$this->_out($s.'>>');
 			$this->_out('endobj');
@@ -1550,6 +1608,6 @@
 		else
 		{
-			//Allow for additional types
-			$mtd='_put'.strtolower($type);
+			// Allow for additional types
+			$mtd = '_put'.strtolower($type);
 			if(!method_exists($this,$mtd))
 				$this->Error('Unsupported font type: '.$type);
@@ -1561,47 +1619,61 @@
 function _putimages()
 {
-	$filter=($this->compress) ? '/Filter /FlateDecode ' : '';
-	reset($this->images);
-	while(list($file,$info)=each($this->images))
-	{
+	foreach(array_keys($this->images) as $file)
+	{
+		$this->_putimage($this->images[$file]);
+		unset($this->images[$file]['data']);
+		unset($this->images[$file]['smask']);
+	}
+}
+
+function _putimage(&$info)
+{
+	$this->_newobj();
+	$info['n'] = $this->n;
+	$this->_out('<</Type /XObject');
+	$this->_out('/Subtype /Image');
+	$this->_out('/Width '.$info['w']);
+	$this->_out('/Height '.$info['h']);
+	if($info['cs']=='Indexed')
+		$this->_out('/ColorSpace [/Indexed /DeviceRGB '.(strlen($info['pal'])/3-1).' '.($this->n+1).' 0 R]');
+	else
+	{
+		$this->_out('/ColorSpace /'.$info['cs']);
+		if($info['cs']=='DeviceCMYK')
+			$this->_out('/Decode [1 0 1 0 1 0 1 0]');
+	}
+	$this->_out('/BitsPerComponent '.$info['bpc']);
+	if(isset($info['f']))
+		$this->_out('/Filter /'.$info['f']);
+	if(isset($info['dp']))
+		$this->_out('/DecodeParms <<'.$info['dp'].'>>');
+	if(isset($info['trns']) && is_array($info['trns']))
+	{
+		$trns = '';
+		for($i=0;$i<count($info['trns']);$i++)
+			$trns .= $info['trns'][$i].' '.$info['trns'][$i].' ';
+		$this->_out('/Mask ['.$trns.']');
+	}
+	if(isset($info['smask']))
+		$this->_out('/SMask '.($this->n+1).' 0 R');
+	$this->_out('/Length '.strlen($info['data']).'>>');
+	$this->_putstream($info['data']);
+	$this->_out('endobj');
+	// Soft mask
+	if(isset($info['smask']))
+	{
+		$dp = '/Predictor 15 /Colors 1 /BitsPerComponent 8 /Columns '.$info['w'];
+		$smask = array('w'=>$info['w'], 'h'=>$info['h'], 'cs'=>'DeviceGray', 'bpc'=>8, 'f'=>$info['f'], 'dp'=>$dp, 'data'=>$info['smask']);
+		$this->_putimage($smask);
+	}
+	// Palette
+	if($info['cs']=='Indexed')
+	{
+		$filter = ($this->compress) ? '/Filter /FlateDecode ' : '';
+		$pal = ($this->compress) ? gzcompress($info['pal']) : $info['pal'];
 		$this->_newobj();
-		$this->images[$file]['n']=$this->n;
-		$this->_out('<</Type /XObject');
-		$this->_out('/Subtype /Image');
-		$this->_out('/Width '.$info['w']);
-		$this->_out('/Height '.$info['h']);
-		if($info['cs']=='Indexed')
-			$this->_out('/ColorSpace [/Indexed /DeviceRGB '.(strlen($info['pal'])/3-1).' '.($this->n+1).' 0 R]');
-		else
-		{
-			$this->_out('/ColorSpace /'.$info['cs']);
-			if($info['cs']=='DeviceCMYK')
-				$this->_out('/Decode [1 0 1 0 1 0 1 0]');
-		}
-		$this->_out('/BitsPerComponent '.$info['bpc']);
-		if(isset($info['f']))
-			$this->_out('/Filter /'.$info['f']);
-		if(isset($info['parms']))
-			$this->_out($info['parms']);
-		if(isset($info['trns']) && is_array($info['trns']))
-		{
-			$trns='';
-			for($i=0;$i<count($info['trns']);$i++)
-				$trns.=$info['trns'][$i].' '.$info['trns'][$i].' ';
-			$this->_out('/Mask ['.$trns.']');
-		}
-		$this->_out('/Length '.strlen($info['data']).'>>');
-		$this->_putstream($info['data']);
-		unset($this->images[$file]['data']);
+		$this->_out('<<'.$filter.'/Length '.strlen($pal).'>>');
+		$this->_putstream($pal);
 		$this->_out('endobj');
-		//Palette
-		if($info['cs']=='Indexed')
-		{
-			$this->_newobj();
-			$pal=($this->compress) ? gzcompress($info['pal']) : $info['pal'];
-			$this->_out('<<'.$filter.'/Length '.strlen($pal).'>>');
-			$this->_putstream($pal);
-			$this->_out('endobj');
-		}
 	}
 }
@@ -1629,6 +1701,6 @@
 	$this->_putfonts();
 	$this->_putimages();
-	//Resource dictionary
-	$this->offsets[2]=strlen($this->buffer);
+	// Resource dictionary
+	$this->offsets[2] = strlen($this->buffer);
 	$this->_out('2 0 obj');
 	$this->_out('<<');
@@ -1665,5 +1737,5 @@
 		$this->_out('/OpenAction [3 0 R /XYZ null null 1]');
 	elseif(!is_string($this->ZoomMode))
-		$this->_out('/OpenAction [3 0 R /XYZ null null '.($this->ZoomMode/100).']');
+		$this->_out('/OpenAction [3 0 R /XYZ null null '.sprintf('%.2F',$this->ZoomMode/100).']');
 	if($this->LayoutMode=='single')
 		$this->_out('/PageLayout /SinglePage');
@@ -1691,5 +1763,5 @@
 	$this->_putpages();
 	$this->_putresources();
-	//Info
+	// Info
 	$this->_newobj();
 	$this->_out('<<');
@@ -1697,5 +1769,5 @@
 	$this->_out('>>');
 	$this->_out('endobj');
-	//Catalog
+	// Catalog
 	$this->_newobj();
 	$this->_out('<<');
@@ -1703,6 +1775,6 @@
 	$this->_out('>>');
 	$this->_out('endobj');
-	//Cross-ref
-	$o=strlen($this->buffer);
+	// Cross-ref
+	$o = strlen($this->buffer);
 	$this->_out('xref');
 	$this->_out('0 '.($this->n+1));
@@ -1710,5 +1782,5 @@
 	for($i=1;$i<=$this->n;$i++)
 		$this->_out(sprintf('%010d 00000 n ',$this->offsets[$i]));
-	//Trailer
+	// Trailer
 	$this->_out('trailer');
 	$this->_out('<<');
@@ -1718,10 +1790,10 @@
 	$this->_out($o);
 	$this->_out('%%EOF');
-	$this->state=3;
-}
-//End of class
-}
-
-//Handle special IE contype request
+	$this->state = 3;
+}
+// End of class
+}
+
+// Handle special IE contype request
 if(isset($_SERVER['HTTP_USER_AGENT']) && $_SERVER['HTTP_USER_AGENT']=='contype')
 {
Index: /branches/version-2_11-dev/data/module/fpdf/font/courierbi.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/courierbi.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdf/font/courierbi.php	(revision 20993)
@@ -0,0 +1,8 @@
+<?php
+$type = 'Core';
+$name = 'Courier-BoldOblique';
+$up = -100;
+$ut = 50;
+for($i=0;$i<=255;$i++)
+	$cw[chr($i)] = 600;
+?>
Index: /branches/version-2_11-dev/data/module/fpdf/font/timesb.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/timesb.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/font/timesb.php	(revision 20993)
@@ -1,4 +1,8 @@
 <?php
-$fpdf_charwidths['timesB']=array(
+$type = 'Core';
+$name = 'Times-Bold';
+$up = -100;
+$ut = 50;
+$cw = array(
 	chr(0)=>250,chr(1)=>250,chr(2)=>250,chr(3)=>250,chr(4)=>250,chr(5)=>250,chr(6)=>250,chr(7)=>250,chr(8)=>250,chr(9)=>250,chr(10)=>250,chr(11)=>250,chr(12)=>250,chr(13)=>250,chr(14)=>250,chr(15)=>250,chr(16)=>250,chr(17)=>250,chr(18)=>250,chr(19)=>250,chr(20)=>250,chr(21)=>250,
 	chr(22)=>250,chr(23)=>250,chr(24)=>250,chr(25)=>250,chr(26)=>250,chr(27)=>250,chr(28)=>250,chr(29)=>250,chr(30)=>250,chr(31)=>250,' '=>250,'!'=>333,'"'=>555,'#'=>500,'$'=>500,'%'=>1000,'&'=>833,'\''=>278,'('=>333,')'=>333,'*'=>500,'+'=>570,
Index: /branches/version-2_11-dev/data/module/fpdf/font/helvetica.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/helvetica.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/font/helvetica.php	(revision 20993)
@@ -1,4 +1,8 @@
 <?php
-$fpdf_charwidths['helvetica']=array(
+$type = 'Core';
+$name = 'Helvetica';
+$up = -100;
+$ut = 50;
+$cw = array(
 	chr(0)=>278,chr(1)=>278,chr(2)=>278,chr(3)=>278,chr(4)=>278,chr(5)=>278,chr(6)=>278,chr(7)=>278,chr(8)=>278,chr(9)=>278,chr(10)=>278,chr(11)=>278,chr(12)=>278,chr(13)=>278,chr(14)=>278,chr(15)=>278,chr(16)=>278,chr(17)=>278,chr(18)=>278,chr(19)=>278,chr(20)=>278,chr(21)=>278,
 	chr(22)=>278,chr(23)=>278,chr(24)=>278,chr(25)=>278,chr(26)=>278,chr(27)=>278,chr(28)=>278,chr(29)=>278,chr(30)=>278,chr(31)=>278,' '=>278,'!'=>278,'"'=>355,'#'=>556,'$'=>556,'%'=>889,'&'=>667,'\''=>191,'('=>333,')'=>333,'*'=>389,'+'=>584,
Index: /branches/version-2_11-dev/data/module/fpdf/font/symbol.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/symbol.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/font/symbol.php	(revision 20993)
@@ -1,4 +1,8 @@
 <?php
-$fpdf_charwidths['symbol']=array(
+$type = 'Core';
+$name = 'Symbol';
+$up = -100;
+$ut = 50;
+$cw = array(
 	chr(0)=>250,chr(1)=>250,chr(2)=>250,chr(3)=>250,chr(4)=>250,chr(5)=>250,chr(6)=>250,chr(7)=>250,chr(8)=>250,chr(9)=>250,chr(10)=>250,chr(11)=>250,chr(12)=>250,chr(13)=>250,chr(14)=>250,chr(15)=>250,chr(16)=>250,chr(17)=>250,chr(18)=>250,chr(19)=>250,chr(20)=>250,chr(21)=>250,
 	chr(22)=>250,chr(23)=>250,chr(24)=>250,chr(25)=>250,chr(26)=>250,chr(27)=>250,chr(28)=>250,chr(29)=>250,chr(30)=>250,chr(31)=>250,' '=>250,'!'=>333,'"'=>713,'#'=>500,'$'=>549,'%'=>833,'&'=>778,'\''=>439,'('=>333,')'=>333,'*'=>500,'+'=>549,
Index: /branches/version-2_11-dev/data/module/fpdf/font/helveticab.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/helveticab.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/font/helveticab.php	(revision 20993)
@@ -1,4 +1,8 @@
 <?php
-$fpdf_charwidths['helveticaB']=array(
+$type = 'Core';
+$name = 'Helvetica-Bold';
+$up = -100;
+$ut = 50;
+$cw = array(
 	chr(0)=>278,chr(1)=>278,chr(2)=>278,chr(3)=>278,chr(4)=>278,chr(5)=>278,chr(6)=>278,chr(7)=>278,chr(8)=>278,chr(9)=>278,chr(10)=>278,chr(11)=>278,chr(12)=>278,chr(13)=>278,chr(14)=>278,chr(15)=>278,chr(16)=>278,chr(17)=>278,chr(18)=>278,chr(19)=>278,chr(20)=>278,chr(21)=>278,
 	chr(22)=>278,chr(23)=>278,chr(24)=>278,chr(25)=>278,chr(26)=>278,chr(27)=>278,chr(28)=>278,chr(29)=>278,chr(30)=>278,chr(31)=>278,' '=>278,'!'=>333,'"'=>474,'#'=>556,'$'=>556,'%'=>889,'&'=>722,'\''=>238,'('=>333,')'=>333,'*'=>389,'+'=>584,
Index: /branches/version-2_11-dev/data/module/fpdf/font/courier.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/courier.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/font/courier.php	(revision 20993)
@@ -1,7 +1,8 @@
 <?php
+$type = 'Core';
+$name = 'Courier';
+$up = -100;
+$ut = 50;
 for($i=0;$i<=255;$i++)
-	$fpdf_charwidths['courier'][chr($i)]=600;
-$fpdf_charwidths['courierB']=$fpdf_charwidths['courier'];
-$fpdf_charwidths['courierI']=$fpdf_charwidths['courier'];
-$fpdf_charwidths['courierBI']=$fpdf_charwidths['courier'];
+	$cw[chr($i)] = 600;
 ?>
Index: /branches/version-2_11-dev/data/module/fpdf/font/courierb.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/courierb.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdf/font/courierb.php	(revision 20993)
@@ -0,0 +1,8 @@
+<?php
+$type = 'Core';
+$name = 'Courier-Bold';
+$up = -100;
+$ut = 50;
+for($i=0;$i<=255;$i++)
+	$cw[chr($i)] = 600;
+?>
Index: /branches/version-2_11-dev/data/module/fpdf/font/timesi.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/timesi.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/font/timesi.php	(revision 20993)
@@ -1,4 +1,8 @@
 <?php
-$fpdf_charwidths['timesI']=array(
+$type = 'Core';
+$name = 'Times-Italic';
+$up = -100;
+$ut = 50;
+$cw = array(
 	chr(0)=>250,chr(1)=>250,chr(2)=>250,chr(3)=>250,chr(4)=>250,chr(5)=>250,chr(6)=>250,chr(7)=>250,chr(8)=>250,chr(9)=>250,chr(10)=>250,chr(11)=>250,chr(12)=>250,chr(13)=>250,chr(14)=>250,chr(15)=>250,chr(16)=>250,chr(17)=>250,chr(18)=>250,chr(19)=>250,chr(20)=>250,chr(21)=>250,
 	chr(22)=>250,chr(23)=>250,chr(24)=>250,chr(25)=>250,chr(26)=>250,chr(27)=>250,chr(28)=>250,chr(29)=>250,chr(30)=>250,chr(31)=>250,' '=>250,'!'=>333,'"'=>420,'#'=>500,'$'=>500,'%'=>833,'&'=>778,'\''=>214,'('=>333,')'=>333,'*'=>500,'+'=>675,
Index: /branches/version-2_11-dev/data/module/fpdf/font/timesbi.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/timesbi.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/font/timesbi.php	(revision 20993)
@@ -1,4 +1,8 @@
 <?php
-$fpdf_charwidths['timesBI']=array(
+$type = 'Core';
+$name = 'Times-BoldItalic';
+$up = -100;
+$ut = 50;
+$cw = array(
 	chr(0)=>250,chr(1)=>250,chr(2)=>250,chr(3)=>250,chr(4)=>250,chr(5)=>250,chr(6)=>250,chr(7)=>250,chr(8)=>250,chr(9)=>250,chr(10)=>250,chr(11)=>250,chr(12)=>250,chr(13)=>250,chr(14)=>250,chr(15)=>250,chr(16)=>250,chr(17)=>250,chr(18)=>250,chr(19)=>250,chr(20)=>250,chr(21)=>250,
 	chr(22)=>250,chr(23)=>250,chr(24)=>250,chr(25)=>250,chr(26)=>250,chr(27)=>250,chr(28)=>250,chr(29)=>250,chr(30)=>250,chr(31)=>250,' '=>250,'!'=>389,'"'=>555,'#'=>500,'$'=>500,'%'=>833,'&'=>778,'\''=>278,'('=>333,')'=>333,'*'=>500,'+'=>570,
Index: /branches/version-2_11-dev/data/module/fpdf/font/zapfdingbats.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/zapfdingbats.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/font/zapfdingbats.php	(revision 20993)
@@ -1,4 +1,8 @@
 <?php
-$fpdf_charwidths['zapfdingbats']=array(
+$type = 'Core';
+$name = 'ZapfDingbats';
+$up = -100;
+$ut = 50;
+$cw = array(
 	chr(0)=>0,chr(1)=>0,chr(2)=>0,chr(3)=>0,chr(4)=>0,chr(5)=>0,chr(6)=>0,chr(7)=>0,chr(8)=>0,chr(9)=>0,chr(10)=>0,chr(11)=>0,chr(12)=>0,chr(13)=>0,chr(14)=>0,chr(15)=>0,chr(16)=>0,chr(17)=>0,chr(18)=>0,chr(19)=>0,chr(20)=>0,chr(21)=>0,
 	chr(22)=>0,chr(23)=>0,chr(24)=>0,chr(25)=>0,chr(26)=>0,chr(27)=>0,chr(28)=>0,chr(29)=>0,chr(30)=>0,chr(31)=>0,' '=>278,'!'=>974,'"'=>961,'#'=>974,'$'=>980,'%'=>719,'&'=>789,'\''=>790,'('=>791,')'=>690,'*'=>960,'+'=>939,
Index: /branches/version-2_11-dev/data/module/fpdf/font/helveticai.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/helveticai.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/font/helveticai.php	(revision 20993)
@@ -1,4 +1,8 @@
 <?php
-$fpdf_charwidths['helveticaI']=array(
+$type = 'Core';
+$name = 'Helvetica-Oblique';
+$up = -100;
+$ut = 50;
+$cw = array(
 	chr(0)=>278,chr(1)=>278,chr(2)=>278,chr(3)=>278,chr(4)=>278,chr(5)=>278,chr(6)=>278,chr(7)=>278,chr(8)=>278,chr(9)=>278,chr(10)=>278,chr(11)=>278,chr(12)=>278,chr(13)=>278,chr(14)=>278,chr(15)=>278,chr(16)=>278,chr(17)=>278,chr(18)=>278,chr(19)=>278,chr(20)=>278,chr(21)=>278,
 	chr(22)=>278,chr(23)=>278,chr(24)=>278,chr(25)=>278,chr(26)=>278,chr(27)=>278,chr(28)=>278,chr(29)=>278,chr(30)=>278,chr(31)=>278,' '=>278,'!'=>278,'"'=>355,'#'=>556,'$'=>556,'%'=>889,'&'=>667,'\''=>191,'('=>333,')'=>333,'*'=>389,'+'=>584,
Index: /branches/version-2_11-dev/data/module/fpdf/font/helveticabi.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/helveticabi.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/font/helveticabi.php	(revision 20993)
@@ -1,4 +1,8 @@
 <?php
-$fpdf_charwidths['helveticaBI']=array(
+$type = 'Core';
+$name = 'Helvetica-BoldOblique';
+$up = -100;
+$ut = 50;
+$cw = array(
 	chr(0)=>278,chr(1)=>278,chr(2)=>278,chr(3)=>278,chr(4)=>278,chr(5)=>278,chr(6)=>278,chr(7)=>278,chr(8)=>278,chr(9)=>278,chr(10)=>278,chr(11)=>278,chr(12)=>278,chr(13)=>278,chr(14)=>278,chr(15)=>278,chr(16)=>278,chr(17)=>278,chr(18)=>278,chr(19)=>278,chr(20)=>278,chr(21)=>278,
 	chr(22)=>278,chr(23)=>278,chr(24)=>278,chr(25)=>278,chr(26)=>278,chr(27)=>278,chr(28)=>278,chr(29)=>278,chr(30)=>278,chr(31)=>278,' '=>278,'!'=>333,'"'=>474,'#'=>556,'$'=>556,'%'=>889,'&'=>722,'\''=>238,'('=>333,')'=>333,'*'=>389,'+'=>584,
Index: /branches/version-2_11-dev/data/module/fpdf/font/courieri.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/courieri.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdf/font/courieri.php	(revision 20993)
@@ -0,0 +1,8 @@
+<?php
+$type = 'Core';
+$name = 'Courier-Oblique';
+$up = -100;
+$ut = 50;
+for($i=0;$i<=255;$i++)
+	$cw[chr($i)] = 600;
+?>
Index: /branches/version-2_11-dev/data/module/fpdf/font/times.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/font/times.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/font/times.php	(revision 20993)
@@ -1,4 +1,8 @@
 <?php
-$fpdf_charwidths['times']=array(
+$type = 'Core';
+$name = 'Times-Roman';
+$up = -100;
+$ut = 50;
+$cw = array(
 	chr(0)=>250,chr(1)=>250,chr(2)=>250,chr(3)=>250,chr(4)=>250,chr(5)=>250,chr(6)=>250,chr(7)=>250,chr(8)=>250,chr(9)=>250,chr(10)=>250,chr(11)=>250,chr(12)=>250,chr(13)=>250,chr(14)=>250,chr(15)=>250,chr(16)=>250,chr(17)=>250,chr(18)=>250,chr(19)=>250,chr(20)=>250,chr(21)=>250,
 	chr(22)=>250,chr(23)=>250,chr(24)=>250,chr(25)=>250,chr(26)=>250,chr(27)=>250,chr(28)=>250,chr(29)=>250,chr(30)=>250,chr(31)=>250,' '=>250,'!'=>333,'"'=>408,'#'=>500,'$'=>500,'%'=>833,'&'=>778,'\''=>180,'('=>333,')'=>333,'*'=>500,'+'=>564,
Index: /branches/version-2_11-dev/data/module/fpdi/fpdi2tcpdf_bridge.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdi/fpdi2tcpdf_bridge.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdi/fpdi2tcpdf_bridge.php	(revision 20993)
@@ -0,0 +1,163 @@
+<?php
+//
+//  FPDI - Version 1.4.1
+//
+//    Copyright 2004-2011 Setasign - Jan Slabon
+//
+//  Licensed under the Apache License, Version 2.0 (the "License");
+//  you may not use this file except in compliance with the License.
+//  You may obtain a copy of the License at
+//
+//      http://www.apache.org/licenses/LICENSE-2.0
+//
+//  Unless required by applicable law or agreed to in writing, software
+//  distributed under the License is distributed on an "AS IS" BASIS,
+//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//  See the License for the specific language governing permissions and
+//  limitations under the License.
+//
+
+/**
+ * This class is used as a bridge between TCPDF and FPDI
+ * and will create the possibility to use both FPDF and TCPDF
+ * via one FPDI version.
+ * 
+ * We'll simply remap TCPDF to FPDF again.
+ * 
+ * It'll be loaded and extended by FPDF_TPL.
+ */
+class FPDF extends TCPDF {
+    
+	function _putstream($s) {
+		$this->_out($this->_getstream($s));
+	}
+	
+	function _getxobjectdict() {
+        $out = parent::_getxobjectdict();
+        if (count($this->tpls)) {
+            foreach($this->tpls as $tplidx => $tpl) {
+                $out .= sprintf('%s%d %d 0 R', $this->tplprefix, $tplidx, $tpl['n']);
+            }
+        }
+        
+        return $out;
+    }
+	
+    /**
+     * Encryption of imported data by FPDI
+     *
+     * @param array $value
+     */
+    function pdf_write_value(&$value) {
+        switch ($value[0]) {
+    		case PDF_TYPE_STRING:
+				if ($this->encrypted) {
+				    $value[1] = $this->_unescape($value[1]);
+                    $value[1] = $this->_RC4($this->_objectkey($this->_current_obj_id), $value[1]);
+                 	$value[1] = $this->_escape($value[1]);
+                } 
+    			break;
+    			
+			case PDF_TYPE_STREAM:
+			    if ($this->encrypted) {
+			        $value[2][1] = $this->_RC4($this->_objectkey($this->_current_obj_id), $value[2][1]);
+                }
+                break;
+                
+            case PDF_TYPE_HEX:
+            	if ($this->encrypted) {
+                	$value[1] = $this->hex2str($value[1]);
+                	$value[1] = $this->_RC4($this->_objectkey($this->_current_obj_id), $value[1]);
+                    
+                	// remake hexstring of encrypted string
+    				$value[1] = $this->str2hex($value[1]);
+                }
+                break;
+    	}
+    }
+    
+    /**
+     * Unescapes a PDF string
+     *
+     * @param string $s
+     * @return string
+     */
+    function _unescape($s) {
+        $out = '';
+        for ($count = 0, $n = strlen($s); $count < $n; $count++) {
+            if ($s[$count] != '\\' || $count == $n-1) {
+                $out .= $s[$count];
+            } else {
+                switch ($s[++$count]) {
+                    case ')':
+                    case '(':
+                    case '\\':
+                        $out .= $s[$count];
+                        break;
+                    case 'f':
+                        $out .= chr(0x0C);
+                        break;
+                    case 'b':
+                        $out .= chr(0x08);
+                        break;
+                    case 't':
+                        $out .= chr(0x09);
+                        break;
+                    case 'r':
+                        $out .= chr(0x0D);
+                        break;
+                    case 'n':
+                        $out .= chr(0x0A);
+                        break;
+                    case "\r":
+                        if ($count != $n-1 && $s[$count+1] == "\n")
+                            $count++;
+                        break;
+                    case "\n":
+                        break;
+                    default:
+                        // Octal-Values
+                        if (ord($s[$count]) >= ord('0') &&
+                            ord($s[$count]) <= ord('9')) {
+                            $oct = ''. $s[$count];
+                                
+                            if (ord($s[$count+1]) >= ord('0') &&
+                                ord($s[$count+1]) <= ord('9')) {
+                                $oct .= $s[++$count];
+                                
+                                if (ord($s[$count+1]) >= ord('0') &&
+                                    ord($s[$count+1]) <= ord('9')) {
+                                    $oct .= $s[++$count];    
+                                }                            
+                            }
+                            
+                            $out .= chr(octdec($oct));
+                        } else {
+                            $out .= $s[$count];
+                        }
+                }
+            }
+        }
+        return $out;
+    }
+    
+    /**
+     * Hexadecimal to string
+     *
+     * @param string $hex
+     * @return string
+     */
+    function hex2str($hex) {
+    	return pack('H*', str_replace(array("\r", "\n", ' '), '', $hex));
+    }
+    
+    /**
+     * String to hexadecimal
+     *
+     * @param string $str
+     * @return string
+     */
+    function str2hex($str) {
+        return current(unpack('H*', $str));
+    }
+}
